	// ===============================================================
	// Global Var
	// ===============================================================
	
	// Edit Handler
	// _______________________________________________________________________
	var EDIT_HANDLER = function(){};	
	EDIT_HANDLER.REF_IS_MODIFIED = false;
	EDIT_HANDLER.HAS_NEWLY_SAVED_DATA = false;
	var PROPERTY_PARENT_ID = 0;
	var PROPERTY_PARENT_DESCRIPTION = "";
	
	
	// Cache
	// _______________________________________________________________________
	var PROPERTY_CAT_PROVINCE_ID = -1;
	var PROPERTY_EDIT_MODE = false;
	var PROPERTY_EDIT_ROW_INDEX = -1;
	var INPUT_INSTANCE = null;
	
	
	// Buttons [Optional]
	// _______________________________________________________________________
	var ADD_BBI = null;
	var SAVE_BBI = null;
	var DELETE_BBI = null;
	var CANCEL_BBI = null;
	var NAVIGATION_BACK_BBI = null;
	
	var SEARCH_CMD = null;
	var PRINT_BBI = null;
	var EXPORT_BBI = null;
	
	
	// Dialog Controls [Optional]
	// _______________________________________________________________________
	var PARENT_DESCRIPTION_TXT = null;
	var CAT_PROVINCE_CODE_TXT = null;
	var CAT_PROVINCE_CODE_B_TXT = null;
	var CAT_PROVINCE_CODE_C_TXT = null;
	var CAT_PROVINCE_DESCRIPTION_TXT = null;
	var CAT_PROVINCE_DESCRIPTION_B_TXT = null;
	var CAT_PROVINCE_DESCRIPTION_C_TXT = null;
	var CAT_PROVINCE_STATUS_CMB = null;
	var PARAM_CAT_PROVINCE_ID_FILE_FP = null;
	
	
	// DGV Controls
	// _______________________________________________________________________
	var ADDRESS_PROVINCE_DGV = null;


	// ===============================================================
	// Initialize Controls
	// ===============================================================     
	function FORM_INITIALIZE()
	{
		// Load Cache Parent Data [Add Redirects if this is a required data.]
		// ...........................................
		if(JSVC_COOKIE.VAR_ISSET("PROPERTY_PARENT_ID_ADDRESS_PROVINCE"))
		{
			PROPERTY_PARENT_ID = JSVC_COOKIE.VAR_READ("PROPERTY_PARENT_ID_ADDRESS_PROVINCE");
		}	
		else
		{
			window.location = JSCUS_CACHE.SERVER_URL + '/p/category/address_region.html';	
			return;
			//window.location = JSCUS_CACHE.AUTH_REDIRECT_URL[JSCUS_CACHE.LOGIN_CLASS];
			//window.close();
		}
		if(JSVC_COOKIE.VAR_ISSET("PROPERTY_PARENT_DESCRIPTION_ADDRESS_PROVINCE"))
		{
			PROPERTY_PARENT_DESCRIPTION = JSVC_COOKIE.VAR_READ("PROPERTY_PARENT_DESCRIPTION_ADDRESS_PROVINCE");
			if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("PAGE_PARENT_DESCRIPTION_TXT") == true)
			{
				JSOC_ELEMENT.VAR_VALUE("PAGE_PARENT_DESCRIPTION_TXT", PROPERTY_PARENT_DESCRIPTION);			
			}
			if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("PAGE_PARENT_DESCRIPTION_LBL") == true)
			{
				JSOC_ELEMENT.VAR_VALUE("PAGE_PARENT_DESCRIPTION_LBL", PROPERTY_PARENT_DESCRIPTION);			
			}
			if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("PAGE_TITLE_LBL") == true)
			{
				JSOC_ELEMENT.VAR_VALUE("PAGE_TITLE_LBL", JSOC_ELEMENT.VAR_VALUE("PAGE_TITLE_LBL") + " - " + PROPERTY_PARENT_DESCRIPTION);	
			}
		}	
		else
		{
			//window.location = JSCUS_CACHE.AUTH_REDIRECT_URL[JSCUS_CACHE.LOGIN_CLASS];	
		}
	
		// Restore Cache on reload
		// ...........................................	
		if
		(
			JSVC_COOKIE.VAR_ISSET("PROPERTY_PARENT_ID_ADDRESS_PROVINCE") || 
			JSVC_COOKIE.VAR_ISSET("PROPERTY_PARENT_DESCRIPTION_ADDRESS_PROVINCE")
		)
		{
			  window.onbeforeunload = function(event)
			  {
					// Get Current Root path
					var CURRENT_ROOT_PATH = JSCUS_CACHE.ROOT_PATH + JSVC_STR.VAR_MID(JSVC_STR.VAR_DLEFT(JSCUS_CACHE.AUTH_REDIRECT_URL[JSCUS_CACHE.LOGIN_CLASS], JSCUS_CACHE.SERVER_URL.length), 1, 1);
				
					// Cache Primary Key
					JSVC_COOKIE.VAR_ADD
					(
						'PROPERTY_PARENT_ID_ADDRESS_PROVINCE', 
						PROPERTY_PARENT_ID, 
						5, 
						CURRENT_ROOT_PATH
					);
					
					// Cache Description
					JSVC_COOKIE.VAR_ADD
					(
						'PROPERTY_PARENT_DESCRIPTION_ADDRESS_PROVINCE', 
						PROPERTY_PARENT_DESCRIPTION, 
						5, 
						CURRENT_ROOT_PATH
					);
			  };
		}
		
		// Assign Fixed Parent
		// ...........................................
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("CAT_PROVINCE_CAT_REGION_ID_CMB"))
		{
			JSOC_CMB.VAR_ADD
			(
				"CAT_PROVINCE_CAT_REGION_ID_CMB", 
				PROPERTY_PARENT_ID,
				PROPERTY_PARENT_DESCRIPTION
			);
		}
		
 		// Cache Class Properties
		// ...........................................
		if(JSVC_COOKIE.VAR_ISSET("PROPERTY_CAT_PROVINCE_ID"))
		{
			PROPERTY_CAT_PROVINCE_ID = JSVC_COOKIE.VAR_READ("PROPERTY_CAT_PROVINCE_ID");
		}	
		if(JSVC_COOKIE.VAR_ISSET("PROPERTY_PARENT_ID"))
		{
			PROPERTY_CAT_PROVINCE_CAT_REGION_ID = JSVC_COOKIE.VAR_READ("PROPERTY_PARENT_ID");
		}	
		if(JSVC_COOKIE.VAR_ISSET("PROPERTY_PARENT_DESCRIPTION"))
		{
			PROPERTY_PARENT_DESCRIPTION = JSVC_COOKIE.VAR_READ("PROPERTY_PARENT_DESCRIPTION");
		}	
		if(JSVC_COOKIE.VAR_ISSET("PROPERTY_EDIT_MODE"))
		{
			PROPERTY_EDIT_MODE = JSVC_COOKIE.VAR_READ("PROPERTY_CAT_PROVINCE_ID");
		}
	
		// Initialize: Modals
		// ...........................................
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("ADDRESS_PROVINCE_MODAL") == true)
		{
			// Display Modal
			JSOC_DIALOG.VAR_MODAL("ADDRESS_PROVINCE_MODAL", false);
		}
				
		// Initialize: Ribbon Buttons [Add Item]
		// ...........................................
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("ADD_BBI"))
		{
    		ADD_BBI = JSOC_ELEMENT.VAR_GET("ADD_BBI");     	
			
			// Add OnClick event [Show Modal]
			if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("ADDRESS_PROVINCE_MODAL"))
			{
				ADD_BBI.onclick = 
					function()
					{		
						// Display Modal
						PROPERTY_CAT_PROVINCE_ID = FLAG_BIGINT_NULL;
						PROPERTY_EDIT_ROW_INDEX = -1;
						
						if(JSVC_VAR.VAR_ISSET(INPUT_INSTANCE))
						{
							JSOC_WINDOW.VAR_INPUT_INSTANCE_RESTORE(INPUT_INSTANCE);
						}
						EDIT_HANDLER.REF_IS_MODIFIED = false;
						JSOC_DIALOG.VAR_MODAL("ADDRESS_PROVINCE_MODAL", true);
					}		
			}
			// Add OnClick event [Show Add/Edit Page]
			else
			{
				
			}
		}	
		
		// Initialize: Ribbon Buttons [Save Changes]
		// ...........................................
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SAVE_BBI"))
		{
    		SAVE_BBI = JSOC_ELEMENT.VAR_GET("SAVE_BBI");     
			if(JSVC_VAR.VAR_ISSET(HTTP_SAVE))
			{
				// Prepare Save callback
				var CALLBACK_HANDLER = 
					function(IS_SUCCESS)
					{
						// Abort on failure
						if(IS_SUCCESS == false)
						{
							return;
						}
					
						// Show record saved messageBox
						JSVC_INFO.VAR_RECORD_SAVED('');
					}
				
				// Add OnClick event
				SAVE_BBI.onclick = 
					function()
					{
						HTTP_SAVE(CALLBACK_HANDLER);
					}
			}
		}
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("CANCEL_BBI"))
		{
    		CANCEL_BBI = JSOC_ELEMENT.VAR_GET("CANCEL_BBI");      		
		}
		
		// Initialize: Ribbon Buttons [Add Back Link (to parent page)]
		// ...........................................
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("NAVIGATION_BACK_BBI"))
		{
    		NAVIGATION_BACK_BBI = JSOC_ELEMENT.VAR_GET("NAVIGATION_BACK_BBI");  
			
			// Add OnClick event
			NAVIGATION_BACK_BBI.onclick = 
				function()
				{
					window.location = JSCUS_CACHE.SERVER_URL + '/p/category/address_region.html';
				}		
		}
		
		// Initialize: Ribbon Buttons [Add Forward Link (to child page)]
		// ...........................................
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("NAVIGATION_BACK_BBI"))
		{
    		NAVIGATION_BACK_BBI = JSOC_ELEMENT.VAR_GET("NAVIGATION_BACK_BBI");  
			
			// Add OnClick event
			NAVIGATION_BACK_BBI.onclick = 
				function()
				{
					window.location = JSCUS_CACHE.SERVER_URL + '/p/category/address_region.html';
				}		
		}

		// Initialize: Ribbon Buttons [Add Search]
		// ...........................................
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_CMD"))
		{
			SEARCH_CMD = JSOC_ELEMENT.VAR_GET("SEARCH_CMD");
			SEARCH_CMD.onclick = function(){HTTP_SEARCH()};
		}		

		// Initialize: Ribbon Buttons [Add Print]
		// ...........................................
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("PRINT_BBI"))
		{
			PRINT_BBI = JSOC_ELEMENT.VAR_GET("PRINT_BBI");
			PRINT_BBI.onclick = function()
			{
				window.print();
			};
		}		
		
		// Initialize: Ribbon Buttons [Add Search]
		// ...........................................
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("EXPORT_BBI"))
		{
			EXPORT_BBI = JSOC_ELEMENT.VAR_GET("EXPORT_BBI");
			EXPORT_BBI.onclick = function()
			{
				JSRC_EXCEL.REF_EXPORT('ADDRESS_PROVINCE_DGV');
			};
		}		

		
		// Prepare onChange event
		// ...........................................
		var ON_CHANGE_EVENT = '';
		
		
		// Initialize: Input Controls
		// ...........................................
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("PARENT_DESCRIPTION_TXT"))
		{
    		PARENT_DESCRIPTION_TXT = JSOC_ELEMENT.VAR_GET("PARENT_DESCRIPTION_TXT");      		
		}
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("CAT_PROVINCE_ID_TXT"))
		{
			CAT_PROVINCE_ID_TXT = JSOC_ELEMENT.VAR_GET("CAT_PROVINCE_ID_TXT");      
			CAT_PROVINCE_ID_TXT.onchange = 
				function()
				{
					if(CAT_PROVINCE_ID_TXT.disabled == false)
					{
						EDIT_HANDLER.REF_IS_MODIFIED = true;
					}
				};
			CAT_PROVINCE_ID_TXT.onkeypress = function(){CAT_PROVINCE_ID_TXT.onchange();};
			CAT_PROVINCE_ID_TXT.onpaste = function(){CAT_PROVINCE_ID_TXT.onchange();};
			CAT_PROVINCE_ID_TXT.oninput = function(){CAT_PROVINCE_ID_TXT.onchange();};
		}
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("CAT_PROVINCE_GLOBAL_ID_TXT"))
		{
			CAT_PROVINCE_GLOBAL_ID_TXT = JSOC_ELEMENT.VAR_GET("CAT_PROVINCE_GLOBAL_ID_TXT");      
			CAT_PROVINCE_GLOBAL_ID_TXT.onchange = 
				function()
				{
					if(CAT_PROVINCE_GLOBAL_ID_TXT.disabled == false)
					{
						EDIT_HANDLER.REF_IS_MODIFIED = true;
					}
				};
			CAT_PROVINCE_GLOBAL_ID_TXT.onkeypress = function(){CAT_PROVINCE_GLOBAL_ID_TXT.onchange();};
			CAT_PROVINCE_GLOBAL_ID_TXT.onpaste = function(){CAT_PROVINCE_GLOBAL_ID_TXT.onchange();};
			CAT_PROVINCE_GLOBAL_ID_TXT.oninput = function(){CAT_PROVINCE_GLOBAL_ID_TXT.onchange();};
		}
		
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("CAT_PROVINCE_CODE_TXT"))
		{
			CAT_PROVINCE_CODE_TXT = JSOC_ELEMENT.VAR_GET("CAT_PROVINCE_CODE_TXT");      
			CAT_PROVINCE_CODE_TXT.onchange = 
				function()
				{
					if(CAT_PROVINCE_CODE_TXT.disabled == false)
					{
						EDIT_HANDLER.REF_IS_MODIFIED = true;
					}
				};
			CAT_PROVINCE_CODE_TXT.onkeypress = function(){CAT_PROVINCE_CODE_TXT.onchange();};
			CAT_PROVINCE_CODE_TXT.onpaste = function(){CAT_PROVINCE_CODE_TXT.onchange();};
			//CAT_PROVINCE_CODE_TXT.oninput = function(){CAT_PROVINCE_CODE_TXT.onchange();};
		}
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("CAT_PROVINCE_CODE_B_TXT"))
		{
			CAT_PROVINCE_CODE_B_TXT = JSOC_ELEMENT.VAR_GET("CAT_PROVINCE_CODE_B_TXT");      
			CAT_PROVINCE_CODE_B_TXT.onchange = 
				function()
				{
					if(CAT_PROVINCE_CODE_B_TXT.disabled == false)
					{
						EDIT_HANDLER.REF_IS_MODIFIED = true;
					}
				};
			CAT_PROVINCE_CODE_B_TXT.onkeypress = function(){CAT_PROVINCE_CODE_B_TXT.onchange();};
			CAT_PROVINCE_CODE_B_TXT.onpaste = function(){CAT_PROVINCE_CODE_B_TXT.onchange();};
			//CAT_PROVINCE_CODE_B_TXT.oninput = function(){CAT_PROVINCE_CODE_B_TXT.onchange();};
		}
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("CAT_PROVINCE_CODE_C_TXT"))
		{
			CAT_PROVINCE_CODE_C_TXT = JSOC_ELEMENT.VAR_GET("CAT_PROVINCE_CODE_C_TXT");      
			CAT_PROVINCE_CODE_C_TXT.onchange = 
				function()
				{
					if(CAT_PROVINCE_CODE_C_TXT.disabled == false)
					{
						EDIT_HANDLER.REF_IS_MODIFIED = true;
					}
				};
			CAT_PROVINCE_CODE_C_TXT.onkeypress = function(){CAT_PROVINCE_CODE_C_TXT.onchange();};
			CAT_PROVINCE_CODE_C_TXT.onpaste = function(){CAT_PROVINCE_CODE_C_TXT.onchange();};
			//CAT_PROVINCE_CODE_C_TXT.oninput = function(){CAT_PROVINCE_CODE_C_TXT.onchange();};
		}
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("CAT_PROVINCE_DESCRIPTION_TXT"))
		{
			CAT_PROVINCE_DESCRIPTION_TXT = JSOC_ELEMENT.VAR_GET("CAT_PROVINCE_DESCRIPTION_TXT");      
			CAT_PROVINCE_DESCRIPTION_TXT.onchange = 
				function()
				{
					if(CAT_PROVINCE_DESCRIPTION_TXT.disabled == false)
					{
						EDIT_HANDLER.REF_IS_MODIFIED = true;
					}
				};
			CAT_PROVINCE_DESCRIPTION_TXT.onkeypress = function(){CAT_PROVINCE_DESCRIPTION_TXT.onchange();};
			CAT_PROVINCE_DESCRIPTION_TXT.onpaste = function(){CAT_PROVINCE_DESCRIPTION_TXT.onchange();};
			//CAT_PROVINCE_DESCRIPTION_TXT.oninput = function(){CAT_PROVINCE_DESCRIPTION_TXT.onchange();};
		}
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("CAT_PROVINCE_DESCRIPTION_B_TXT"))
		{
			CAT_PROVINCE_DESCRIPTION_B_TXT = JSOC_ELEMENT.VAR_GET("CAT_PROVINCE_DESCRIPTION_B_TXT");      
			CAT_PROVINCE_DESCRIPTION_B_TXT.onchange = 
				function()
				{
					if(CAT_PROVINCE_DESCRIPTION_B_TXT.disabled == false)
					{
						EDIT_HANDLER.REF_IS_MODIFIED = true;
					}
				};
			CAT_PROVINCE_DESCRIPTION_B_TXT.onkeypress = function(){CAT_PROVINCE_DESCRIPTION_B_TXT.onchange();};
			CAT_PROVINCE_DESCRIPTION_B_TXT.onpaste = function(){CAT_PROVINCE_DESCRIPTION_B_TXT.onchange();};
			//CAT_PROVINCE_DESCRIPTION_B_TXT.oninput = function(){CAT_PROVINCE_DESCRIPTION_B_TXT.onchange();};
		}
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("CAT_PROVINCE_DESCRIPTION_C_TXT"))
		{
			CAT_PROVINCE_DESCRIPTION_C_TXT = JSOC_ELEMENT.VAR_GET("CAT_PROVINCE_DESCRIPTION_C_TXT");      
			CAT_PROVINCE_DESCRIPTION_C_TXT.onchange = 
				function()
				{
					if(CAT_PROVINCE_DESCRIPTION_C_TXT.disabled == false)
					{
						EDIT_HANDLER.REF_IS_MODIFIED = true;
					}
				};
			CAT_PROVINCE_DESCRIPTION_C_TXT.onkeypress = function(){CAT_PROVINCE_DESCRIPTION_C_TXT.onchange();};
			CAT_PROVINCE_DESCRIPTION_C_TXT.onpaste = function(){CAT_PROVINCE_DESCRIPTION_C_TXT.onchange();};
			//CAT_PROVINCE_DESCRIPTION_C_TXT.oninput = function(){CAT_PROVINCE_DESCRIPTION_C_TXT.onchange();};
		}
		
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("CAT_PROVINCE_STATUS_CMB"))
		{
			CAT_PROVINCE_STATUS_CMB = JSOC_ELEMENT.VAR_GET("CAT_PROVINCE_STATUS_CMB");      	
			CAT_PROVINCE_STATUS_CMB.onchange = 
				function()
				{
					if(CAT_PROVINCE_STATUS_CMB.disabled == false)
					{
						EDIT_HANDLER.REF_IS_MODIFIED = true;
					}
				};
			CAT_PROVINCE_STATUS_CMB.onkeypress = function(){CAT_PROVINCE_STATUS_CMB.onchange();};
			CAT_PROVINCE_STATUS_CMB.onpaste = function(){CAT_PROVINCE_STATUS_CMB.onchange();};
			CAT_PROVINCE_STATUS_CMB.oninput = function(){CAT_PROVINCE_STATUS_CMB.onchange();};							
		}
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("CAT_PROVINCE_SYSTEM_GENERATED_TXT"))
		{
			CAT_PROVINCE_SYSTEM_GENERATED_TXT = JSOC_ELEMENT.VAR_GET("CAT_PROVINCE_SYSTEM_GENERATED_TXT");      
			CAT_PROVINCE_SYSTEM_GENERATED_TXT.onchange = 
				function()
				{
					if(CAT_PROVINCE_SYSTEM_GENERATED_TXT.disabled == false)
					{
						EDIT_HANDLER.REF_IS_MODIFIED = true;
					}
				};
			CAT_PROVINCE_SYSTEM_GENERATED_TXT.onkeypress = function(){CAT_PROVINCE_SYSTEM_GENERATED_TXT.onchange();};
			CAT_PROVINCE_SYSTEM_GENERATED_TXT.onpaste = function(){CAT_PROVINCE_SYSTEM_GENERATED_TXT.onchange();};
			CAT_PROVINCE_SYSTEM_GENERATED_TXT.oninput = function(){CAT_PROVINCE_SYSTEM_GENERATED_TXT.onchange();};
		}
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("PARAM_CAT_PROVINCE_ID_FILE_FP"))
		{
			PARAM_CAT_PROVINCE_ID_FILE_FP = JSOC_ELEMENT.VAR_GET("PARAM_CAT_PROVINCE_ID_FILE_FP");
		}
				
		
		// Initialize: Default Settings
		// ...........................................
		// FORM_PREPARE_DEFAULT_SETTINGS();   	
	}